/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_SegmentationPropertyCategories;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_SegmentationPropertyCategories;


/**
 * This class represents SegmentationPropertyCategories CID7150
 */
public class SegmentationPropertyCategories_CID7150 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new SegmentationPropertyCategories_CID7150 Template 
	 */
	public SegmentationPropertyCategories_CID7150()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumSegmentationPropertyCategories Object of EnumCM_SegmentationPropertyCategories represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_SegmentationPropertyCategories enumSegmentationPropertyCategories)
	{
		switch(enumSegmentationPropertyCategories) 
		{
		case TISSUE: this.strCodeValue =EnumCV_SegmentationPropertyCategories.TISSUE_T_D0050.getValue(); break;
		case ANATOMICAL_STRUCTURE: this.strCodeValue =EnumCV_SegmentationPropertyCategories.ANATOMICAL_STRUCTURE_T_D000A.getValue(); break;
		case PHYSICAL_OBJECT: this.strCodeValue =EnumCV_SegmentationPropertyCategories.PHYSICAL_OBJECT_A_00004.getValue(); break;
		case MORPHOLOGICALLY_ALTERED_STRUCTURE: this.strCodeValue =EnumCV_SegmentationPropertyCategories.MORPHOLOGICALLY_ALTERED_STRUCTURE_M_01000.getValue(); break;
		case FUNCTION: this.strCodeValue =EnumCV_SegmentationPropertyCategories.FUNCTION_R_42019.getValue(); break;
		case SPATIAL_AND_RELATIONAL_CONCEPT: this.strCodeValue =EnumCV_SegmentationPropertyCategories.SPATIAL_AND_RELATIONAL_CONCEPT_R_42018.getValue(); break;
		case BODY_SUBSTANCE: this.strCodeValue =EnumCV_SegmentationPropertyCategories.BODY_SUBSTANCE_T_D0080.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumSegmentationPropertyCategories Object of EnumCM_SegmentationPropertyCategories represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_SegmentationPropertyCategories enumSegmentationPropertyCategories)
	{
		switch(enumSegmentationPropertyCategories)
		{
		case TISSUE : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.TISSUE.getSNOMEDCTID(); break;
		case ANATOMICAL_STRUCTURE : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.ANATOMICAL_STRUCTURE.getSNOMEDCTID(); break;
		case PHYSICAL_OBJECT : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.PHYSICAL_OBJECT.getSNOMEDCTID(); break;
		case MORPHOLOGICALLY_ALTERED_STRUCTURE : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.MORPHOLOGICALLY_ALTERED_STRUCTURE.getSNOMEDCTID(); break;
		case FUNCTION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.FUNCTION.getSNOMEDCTID(); break;
		case SPATIAL_AND_RELATIONAL_CONCEPT : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.SPATIAL_AND_RELATIONAL_CONCEPT.getSNOMEDCTID(); break;
		case BODY_SUBSTANCE : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.BODY_SUBSTANCE.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for SegmentationPropertyCategories
	 * @param enumSegmentationPropertyCategories Object of EnumCM_SegmentationPropertyCategories.
	 */
	public void setSegmentationPropertyCategories(EnumCM_SegmentationPropertyCategories enumSegmentationPropertyCategories)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumSegmentationPropertyCategories.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumSegmentationPropertyCategories);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumSegmentationPropertyCategories);
	}
}
